//http://www.phidels.com
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    LabeldwMajorVersion: TLabel;
    LabeldwMinorVersion: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Button2: TButton;
    LabelszCSDVersion: TLabel;
    LabelServicePackMajor: TLabel;
    LabelServicePackMinor: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LabelLibelleVersionOS: TLabel;
    LabelWorkstation: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LabelServer: TLabel;
    Label7: TLabel;
    LabelDomainController: TLabel;

    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

  //toutes les versions d'OS ne sont pas capables d'utiliser cette structure.
  //c'est pour cela que dans le programme, si il y a un echec  l'appelle de
  //GetVersionEx, on recommence mais en donnant la taille de TOsVersionInfo
  // et non de TOsVersionInfo. Cela correspond  l'ancienne version de GetVersionEx
  //dans ce cas, on ne pourra pas se servir des variables de ServicePackMajor
  // wReserved (la dclaration de TOsVersionInfo se trouve dans l'unit Windows
  // et correspond  :
  {  TOsVersionInfo = record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of AnsiChar;
  end;}
  TOsVersionInfoEx= record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of AnsiChar; 
    ServicePackMajor:WORD;
    ServicePackMinor:WORD;
    WSuiteMask :WORD;
    wProductType : BYTE;
    wReserved    :BYTE;
  end;


function GetVersionEx(var lpVersionInformation: TOSVersionInfoEx): BOOL; stdcall;

var
  Form1: TForm1;

implementation
{$R *.DFM}

function GetVersionEx; external kernel32 name 'GetVersionExA';



procedure TForm1.Button2Click(Sender: TObject);
const
  VER_NT_WORKSTATION              = $0000001;
  VER_NT_DOMAIN_CONTROLLER        = $0000002;
  VER_NT_SERVER                   = $0000003;
  VER_SUITE_PERSONAL              = $00000200;

var
  OsVersionInfo:TOsVersionInfoEx;
  OSCompatibleTOsVersionInfoEx:Boolean;
  NumMajeurVersionOS:Integer; //num de version de l'OS ex : 5
  NumMineurVersionOS:Integer;//num
  VersionOS:String;   //version de l'OS sous la forme '5.1'
  LibelleVersionOS:String;// version de l'OS sous la forme 'Windows XP'
begin
  fillchar( OsVersionInfo,sizeof(OsVersionInfo),0);
  OSCompatibleTOsVersionInfoEx:=true;
  //toutes les versions d'OS ne sont pas capable d'utiliser la structure
  //TOsVersionInfoEx.
  //c'est pour cela que dans le programme, si il y a un echec  l'appelle de
  //GetVersionEx, on recommence mais en donnant la taille de TOsVersionInfo
  //dans ce cas, on ne pourra pas se servir des champ de ServicePackMajor
  // wReserved. La dclaration de TOsVersionInfo se trouve dans l'unit Windows
  // et correspond  :
  {  TOsVersionInfo = record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of AnsiChar;
  end;}

  //information de la taille de TOsVersionInfoEx)  faire avant tout appel
  //  GetVersionEx
  OsVersionInfo.dwOSVersionInfoSize:=sizeof(TOsVersionInfoEx);
  if not GetVersionEx(OsVersionInfo) then
  begin
    OsVersionInfo.dwOSVersionInfoSize:=sizeof(TOsVersionInfo);
    GetVersionEx(OsVersionInfo);
    OSCompatibleTOsVersionInfoEx:=False;;
  end;
  NumMajeurVersionOS:=OsVersionInfo.dwMajorVersion;
  NumMineurVersionOS:=OsVersionInfo.dwMinorVersion;
  VersionOS:=IntToStr(NumMajeurVersionOS)+'.'+IntToStr(NumMineurVersionOS);

  if OsVersionInfo.dwPlatformId=VER_PLATFORM_WIN32s
                                               then LibelleVersionOS:='Win 3.1';

  if NumMajeurVersionOS=3 then
  begin
     if NumMineurVersionOS=51 then LibelleVersionOS:='Windows NT';
  end;
  if NumMajeurVersionOS=4 then
  begin
    case NumMineurVersionOS of
      0  : begin
             if(OsVersionInfo.dwPlatformId=VER_PLATFORM_WIN32_WINDOWS) then
               begin
                 LibelleVersionOS:='Windows 95';
                       if (OsVersionInfo.szCSDVersion[1] in ['B', 'C']) then
                                 LibelleVersionOS := LibelleVersionOS +' OSR2';
               end
             else
               LibelleVersionOS:='Windows NT 4.0';
           end;
      10 : begin
             LibelleVersionOS:='Windows 98';
             if (OsVersionInfo.szCSDVersion[1] = 'A') then
                                  LibelleVersionOS := LibelleVersionOS + ' SE';
           end;
      90 : LibelleVersionOS:='Windows Millenium';
    end;

  end;
  if NumMajeurVersionOS=5 then
  begin
    case NumMineurVersionOS of
       0 : LibelleVersionOS:='Windows 2000';
       1 : begin
             LibelleVersionOS:='Windows XP';
               if OSCompatibleTOsVersionInfoEx
                   and (OsVersionInfo.WSuiteMask and VER_SUITE_PERSONAL<>0) then
                   LibelleVersionOS:=LibelleVersionOS+' Home Edition';
           end;
       2 : LibelleVersionOS:='Windows SERVEUR 2003';
    end;
  end;
  if NumMajeurVersionOS=6 then LibelleVersionOS:='Windows Longhorn';

  //pour plus d'infos, allez voir sur http://msdn.microsoft.com/library/
  //         default.asp?url=/library/en-us/sysinfo/base/osversioninfoex_str.asp

  LabelLibelleVersionOS.Caption:= LibelleVersionOS;
  LabeldwMajorVersion.Caption:=IntToStr(OsVersionInfo.dwMajorVersion);
  LabeldwMinorVersion.Caption:=IntToStr(OsVersionInfo.dwMinorVersion);
  LabelszCSDVersion.Caption:=string(OsVersionInfo.szCSDVersion);
  if OSCompatibleTOsVersionInfoEx then //voir commentaire plus haut
  begin
    LabelServicePackMajor.Caption:=IntToStr(OsVersionInfo.ServicePackMajor);
    LabelServicePackMinor.Caption:=IntToStr(OsVersionInfo.ServicePackMinor);
    if (OsVersionInfo.wProductType and VER_NT_WORKSTATION<>0) then
             LabelWorkstation.Caption:='OUI' else LabelWorkstation.Caption:='NON';
    if (OsVersionInfo.wProductType and VER_NT_SERVER<>0) then
             LabelServer.Caption:='OUI' else LabelServer.Caption:='NON';
    if (OsVersionInfo.wProductType and VER_NT_DOMAIN_CONTROLLER<>0) then
      LabelDomainController.Caption:='OUI' else LabelDomainController.Caption:='NON';
  end
  else
  begin
     LabelServicePackMajor.Caption:='Non connu';
     LabelServicePackMinor.Caption:='Non connu';
     LabelWorkstation.Caption:='Non connu';
     LabelServer.Caption:='Non connu';
     LabelDomainController.Caption:='Non connu';
  end;
end;

end.




